import * as T from "./Types";
import * as I from "./Interfaces"

export interface Exporter{
    name: T.Name
    localRPCs() : T.RPC[]
    publicRPCs() : T.RPC[]
}

export interface Socket {
    port: number
    hook: (rpcname: T.Name, ...args: T.Any[]) => I.Socket
    unhook: (rpcname:T.Name) => I.Socket
    call: (rpcname:T.Name, ...args: T.Any[]) => Promise<T.Any>
    fire: (rpcname:T.Name, ...args: T.Any[]) => Promise<T.Any>
    on: T.OnFunction
    destroy: ()=>void
    close: ()=>void
}